type JSONPointerReplacer = (value: any, key: string, parent: any, paths: string[]) => void;
export declare const escape: (str: string | number) => string;
export declare const unescape: (str: string) => string;
export declare const parse: (pointer: string) => string[];
export declare const has: <T extends {}>(obj: T, pointer: string) => boolean;
export declare const compile: (paths: (string | number)[], encoding?: "uri") => string;
export declare const resolve: <T extends {}, V extends unknown, P extends string>(doc: T, pointer: P, callback?: JSONPointerReplacer) => V;
export declare const get: <T extends {}, R extends unknown>(json: T, pointer: string) => R;
export declare const remove: <T extends {}>(json: T, pointer: string) => T;
export declare const dict: <T extends {}>(json: T) => Record<string, unknown>;
export declare const compose: <T extends {}, Initial extends T = T, Result extends any = T>(entriesOrRecord: [string, any][] | Record<string, unknown>, initial?: Initial) => Result;
export declare const set: <T extends {}>(doc: T, pointer: string, nextValue: any) => T;
export declare const read: <T extends {}>(json: T, pointer: string) => unknown;
export declare const transform: <T extends {}, Fn extends (params: unknown) => unknown>(doc: T, pointer: string, fn: Fn) => T;
export declare const chain: <T>(...operations: ((val: T) => T)[]) => (source: T) => T;
export {};
