import { JSONPointer, JSONPointerString, CompiledPointer, DictResult, ParsedPath } from './types';
export declare const get: <T extends {}, P extends string>(json: T, pointer: P) => JSONPointer<T, P>;
export declare const has: <T extends {}, P extends string>(obj: T, pointer: P) => boolean;
export declare const set: <T extends {}, P extends string, V extends JSONPointer<T, P>>(doc: T, pointer: P, value: V) => T;
export declare const remove: <T extends {}, P extends string>(json: T, pointer: P) => T;
export declare const read: <T extends {}, P extends string>(json: T, pointer: P) => JSONPointer<T, P> | undefined;
export declare const transform: <T extends {}, P extends string, V extends JSONPointer<T, P>, R extends JSONPointer<T, P>>(doc: T, pointer: P, fn: (value: V) => R) => T;
export declare const resolve: <T extends {}, P extends string>(doc: T, pointer: P, callback?: (value: JSONPointer<T, P>, key: string, parent: any, paths: string[]) => void) => JSONPointer<T, P>;
export declare const parse: <P extends string>(pointer: P) => ParsedPath;
export declare const compile: <E extends "uri" | undefined = undefined>(paths: (string | number)[], encoding?: E) => CompiledPointer<E>;
export declare const dict: <T extends {}>(json: T) => DictResult<T>;
export declare const compose: <T extends {}, Initial extends T = T, Result extends any = T>(entriesOrRecord: [JSONPointerString, any][] | Record<JSONPointerString, unknown>, initial?: Initial) => Result;
export declare const chain: <T>(...operations: ((val: T) => T)[]) => (source: T) => T, escape: (str: string | number) => string, unescape: (str: string) => string;
